DEFINE CLASS myheader AS header
	
	Enabled=.t.
	*-- Temporary Image File that contains the gradient image
	HIDDEN ctempgradfile
	ctempgradfile = ""
	*-- Original Picture File selected
	HIDDEN coriginalpicture
	coriginalpicture = ""
	*-- Destination Color for the Gradient background
	backcolor2 = 0
	*-- Convert WHITES from Image BackGround to Transparent
	transpimgback = .F.
	*-- RGB color to become transparent
	maketransparentcolor = (rgb(255,255,255))
	*-- GDI+ Graphics object
	HIDDEN ogfx
	ogfx = 0
	*-- GDI+ Bitmap object
	HIDDEN obmp
	obmp = 0
	*-- GDI+ Picture (Image) object
	HIDDEN opict
	opict = 0
	HIDDEN ctempfilename
	ctempfilename = ""
	*-- GDI+ Graphics Handle
	HIDDEN hgfx
	hgfx = 0
	*-- GDI+ Picture handle
	HIDDEN hpict
	hpict = 0
	*-- GDI+ Bitmap handle
	HIDDEN hbmp
	hbmp = 0
	*-- Gdi+ Format object
	HIDDEN oFormat
	oFormat = 0
	*-- Gdi+ Size object
	HIDDEN osize
	osize = 0
	*-- Gdi+ Font object
	HIDDEN ofont
	ofont = 0
	*-- GDI+ SolidBrush object
	HIDDEN osolidbrush
	osolidbrush = 0
	*-- GDI+ Point to draw string
	HIDDEN ctextpoint
	ctextpoint = ""
	HIDDEN xpict
	xpict = 0
	HIDDEN ypict
	ypict = 0
	HIDDEN pictwidth
	pictwidth = .F.
	HIDDEN pictheight
	pictheight = 0
	HIDDEN cgradpoint1
	cgradpoint1 = ""
	HIDDEN cgradpoint2
	cgradpoint2 = ""
	*-- GDI+ ColorMap for transforming picture backgrounds to transparent
	HIDDEN ccolormap
	ccolormap = ""
	*-- GDI+ Font Handle
	HIDDEN hfont
	hfont = 0
	*-- GDI+ SolidBrush Handle
	HIDDEN hsolidbrush
	hsolidbrush = 0
	Name = "myHeader"

	*-- Returns the ARGB value for a given RGB value
	HIDDEN PROCEDURE makeargb
		LPARAMETERS tnColor, tnAlpha
			Local argb, red, green, blue
			blue = Bitrshift(Bitand(tnColor, 0x00FF0000), 16)
			green = Bitrshift(Bitand(tnColor, 0x0000FF00), 8)
			red = Bitand(tnColor, 0x000000FF)
			argb = blue + Bitlshift(green, 8) + Bitlshift(red, 16)
			If Vartype(tnAlpha) = 'N'
				argb = argb + Bitlshift(Bitand(tnAlpha, 0xFF), 24)
			Else
				argb = argb + Bitlshift(255, 24)
			ENDIF
			RETURN ARGB
	ENDPROC

	*-- Makes color brighter or darker
	HIDDEN PROCEDURE changecolors
		LPARAMETERS tnRGB, tnLevel
		tnLevel = tnLevel / 100

		LOCAL lnRed, lnGreen, lnBlue
		lnRed   = BITAND(tnRGB, 0x000000FF)
		lnGreen = BITRSHIFT(BITAND(tnRGB, 0x0000FF00), 8)
		lnBlue  = BITRSHIFT(BITAND(tnRGB, 0x00FF0000), 16)

		RETURN RGB(lnRed   + ((255 - lnRed)   * tnLevel) , ;
				   lnGreen + ((255 - lnGreen) * tnLevel) , ;
				   lnBlue  + ((255 - lnBlue)  * tnLevel) )
	ENDPROC


	HIDDEN PROCEDURE declareapi
		* Declare API
		DECLARE INTEGER GdipCreateImageAttributes IN GDIPLUS.DLL ;
		   INTEGER @ImgAttr

		DECLARE INTEGER GdipSetImageAttributesRemapTable IN GDIPLUS.DLL ;
		   INTEGER imageattr, ;
		   INTEGER ColorAdjustType, ;
		   INTEGER enableFlag, ;
		   INTEGER mapsize, ;
		   STRING  colorMap

		DECLARE INTEGER GdipDisposeImageAttributes IN GDIPLUS.DLL ;
		   INTEGER imageattr

		DECLARE INTEGER GdipDrawImageRectRect IN GDIPLUS.DLL ;
		   INTEGER Graphics, INTEGER nImage, ;
		   SINGLE dstx, SINGLE dsty, SINGLE dstwidth, SINGLE dstheight, ;
		   SINGLE srcx, SINGLE srcy, SINGLE srcwidth, SINGLE srcheight, ;
		   INTEGER srcUnit, INTEGER imageAttributes, ;
		   INTEGER Callback, INTEGER CallbackData

		DECLARE INTEGER GdipDrawImage IN GDIPLUS.DLL ;
		   INTEGER nGraphics, INTEGER nImage, SINGLE,SINGLE

		DECLARE LONG GdipCreateLineBrushI IN GDIPLUS.DLL ;
		   STRING point1, STRING point2, ;
		   LONG color1, LONG color2, ;
		   LONG wrapMode, LONG @lineGradient

		DECLARE INTEGER GdipFillRectangle IN GDIPLUS.DLL ;
		   INTEGER nGraphics, INTEGER nBrush, SINGLE,SINGLE,SINGLE,SINGLE

		DECLARE INTEGER GdipDeleteBrush IN GDIPLUS.DLL ;
		   INTEGER nBrush

		DECLARE INTEGER GdipMeasureString IN GDIPLUS.DLL ;
			INTEGER nGraphics,STRING cUnicode,INTEGER nLength ;
			,INTEGER nFont,STRING cLayoutRect,INTEGER nStringFormat ;
			, STRING @cRectOut, INTEGER @nChars, INTEGER @nLines

		DECLARE INTEGER GdipDrawString IN GDIPLUS.DLL ;
			INTEGER,STRING,INTEGER,INTEGER,STRING,INTEGER,INTEGER
	ENDPROC


	*-- Draws the gradient Image of the commandbutton, containing the gradient background, Caption and Picture selected
	PROCEDURE draw
		WITH This

		LOCAL y1, x2, y2

		.cTempFilename = ADDBS(SYS(2023))+SYS(2015)
		.cTempGradFile = .cTempFileName + ".png"
		y1 = 0
		x2 = 1
		y2 = .parent.Width

		.cGradPoint1 = BINTOC(0,"4rs")  + BINTOC(y1,"4rs")
		.cGradPoint2 = BINTOC(x2,"4rs") + BINTOC(y2,"4rs")

		.BackColor2 = This.ChangeColors(.BackColor,0)

		* Create a bitmap
		.oBmp = NEWOBJECT("gpBitmap",HOME() + "ffc/_gdiplus.vcx")
		.oBmp.Create(.parent.parent.HeaderHeight,.parent.Width )

		* Get a bitmab graphics object
		.oGfx = NEWOBJECT("gpGraphics",HOME() + "ffc/_gdiplus.vcx")
		.oGfx.CreateFromImage(.oBmp)
		.hGfx = .oGfx.GetHandle()

		* Get a gradient brush
		LOCAL hBrush && Brush Handle
		hBrush = 0
		=GdipCreateLineBrushI(.cGradPoint1, .cGradPoint2, ;
			.MakeARGB(.BackColor), .MakeARGB(.BackColor2), 0, @hBrush)

		* Fill the bitmap with our gradient
		= GdipFillRectangle( .hGfx, hBrush, 0, 0,.parent.parent.HeaderHeight , .parent.Width)

		* Clear the GradientBrush Handle
		= GdipDeleteBrush(hBrush)

		* Draw the Desired picture
		IF NOT EMPTY(.cOriginalPicture) AND FILE(.cOriginalPicture)
			.oPict = NEWOBJECT("gpImage",HOME() + "ffc/_gdiplus.vcx")
			.oPict.CreateFromFile(.cOriginalPicture)
			.hPict = .oPict.GetHandle()

			.PictWidth  = .oPict.ImageWidth
			.PictHeight = .oPict.ImageHeight
			.xPict = 3
			.yPict = (.parent.width - .PictHeight) / 2

			IF .TranspImgBack = .T.

				* Remap Colors
				LOCAL lnHandle1, lnOldColor
				lnHandle1 = This.Parent.hImgAttrib1
				lnOldColor = This.MakeARGB(This.Maketransparentcolor)
				.cColorMap = BINTOC(lnOldColor,"4RS") + BINTOC(0,"4RS")
				=GdipSetImageAttributesRemapTable(lnHandle1, 0 , 1 , 2 , .cColorMap)

				=GdipDrawImageRectRect(.hGfx, .hPict, ;
					.xPict, .yPict, .PictWidth,.PictHeight, ;
					0, 0, .PictWidth, .PictHeight, ;
					2, lnHandle1, 0, 0)
			ELSE
				= GdipDrawImage( .hGfx, .hPict, .xPict, .yPict)
			ENDIF 
		ENDIF

		* Draw the Caption
		#DEFINE fontstyleregular 0
		#DEFINE fontstylebold  1
		#DEFINE fontstyleitalic  2
		#DEFINE fontstyleunderline 4
		#DEFINE fontstylestrikeout 8

		#DEFINE unitpixel  2
		#DEFINE unitpoint  3

		tctxtcap=ALLTRIM(.Caption)
		.tooltiptext=tctxtcap
		.Caption=''
        lnAlignment=.Alignment
        
		IF NOT EMPTY(tctxtcap)
			LOCAL lnFontStyle
			lnFontStyle = fontstyleregular  + ;
				IIF(.FontBold, fontstylebold, 0) +;
				IIF(.FontItalic, fontstyleitalic, 0) +;
				IIF(.FontUnderline, fontstyleunderline, 0) +;
				IIF(.FontStrikethru, fontstylestrikeout, 0)
         
			.oFont = NEWOBJECT('GpFont',HOME() + "ffc/_gdiplus.vcx")
			.oFont.CREATE( .FontName ;  && font name
				, .FontSize ;       && size in units below
				, lnFontStyle ;    && fontStyle
				, unitPOINT )           && units
			.hFont = .oFont.GetHandle()

			.oSolidBrush = NEWOBJECT('GpSolidBrush',HOME() + "ffc/_gdiplus.vcx", "", .MakeARGB(.ForeColor))
			.hSolidBrush = .oSolidBrush.GetHandle()
             
            .oSize   = newobject('GPSize',home() + 'ffc\_gdiplus.vcx')  
            .oFormat = newobject('GPStringFormat',home() + 'ffc\_gdiplus.vcx')
            
            lnChars=0
            lnLines=0
             
			* Measure the Height of one of Caption to calculate vertical position
			LOCAL lcBoundingBox, lnWCap, lnHCap
			lcBoundingBox = REPLICATE(CHR(0),16)
			= GdipMeasureString( .hGfx, STRCONV(tctxtcap,5), LEN(tctxtcap), .hFont ;
				                 , REPLICATE(CHR(0),16)+.oSize.GdipSizeF, .oFormat.GetHandle(), @lcBoundingBox,@lnChars,@lnLines)
			lnWCap = CTOBIN(SUBSTR(lcBoundingBox, 9, 4), 'N')
			lnHCap = CTOBIN(SUBSTR(lcBoundingBox, 13, 4), 'N')
            
            *     
            lctext=''
		  	tnkoff1=lnWCap/.parent.parent.HeaderHeight
			tnkoff=CEILING(tnkoff1) 
			tlwid=INT(LEN(tctxtcap)/tnkoff1)
			FOR jm=0 TO tnkoff
			    tcpar=ALLTRIM(SUBSTR(tctxtcap,jm*tlwid+1,tlwid))
			    IF !EMPTY(tcpar)
				    DO CASE 
				      CASE INLIST(lnAlignment,1,5,8) && right alignment
				         tcpar=PADL(tcpar,tlwid,' ')
				      CASE INLIST(lnAlignment,2,3,6,9) && center alignment
				         tcpar=PADC(tcpar,tlwid,' ')    
				    ENDCASE 
				    lctext=lctext+tcpar+CHR(10)
			    ENDIF 
			ENDFOR 
			tctxtcap=lctext
			LOCAL xCap, yCap
			xCap = 5 
            DO CASE 
              CASE BETWEEN(lnAlignment,4,6) && Top alignment
                  yCap = 0
              CASE BETWEEN(lnAlignment,7,9) && Bottom alignment    
                  yCap = (.parent.width - (lnHCap+5)*(tnkoff))
              OTHERWISE  
                  yCap = (.parent.width - lnHCap*tnkoff) / 2
            ENDCASE 

			.cTextPoint = BINTOC(xCap,'F') + BINTOC(yCap,'F')
			 = GdipDrawString( .hGfx, STRCONV(tctxtcap,5), LEN(tctxtcap), .hFont, .ctextPoint + REPLICATE(CHR(0),8), 0, .hSolidBrush)
		ENDIF
        .oBmp.Rotateflip(3) &&   270 
        
		.oBmp.SaveToFile(.cTempGradFile,"image/png")
		.Picture = .cTempGradFile

		ENDWITH 

		RETURN
	ENDPROC

	*-- Deletes Temporary files used to store the image from this cmdButton
	HIDDEN PROCEDURE deletetemp
		WITH This
			IF FILE(.cTempGradFile)
				CLEAR RESOURCES (.cTempGradFile)
				ERASE (.cTempGradFile)
			ENDIF
		ENDWITH
	ENDPROC

	PROCEDURE Init
		WITH This
		IF TYPE(".Parent.ActiveControl")="U"
			.parent.addproperty("ActiveControl",.null.)
		ENDIF 

		* Create Gradient Image
		.cOriginalPicture = .Picture

		* Check if ImgAttributes Handle already was prepared
		IF NOT PEMSTATUS(.Parent, 'hImgAttrib1',5)
			.DeclareAPI

			* Create a GpImageAttribute to translate the colors
			* and permit to convert picture borders to transparent
			LOCAL nHandle1
			nHandle1 = 0
			=GdipCreateImageAttributes(@nHandle1)
			.Parent.AddProperty("hImgAttrib1",nHandle1)

			* Create a GpImageAttribute to translate the colors
			* and create a colormatrix to create the disabled picture
			LOCAL nHandle2
			nHandle2 = 0
			=GdipCreateImageAttributes(@nHandle2)

			LOCAL lcMatrix
			lcMatrix = ;
			   BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0,"F")+BINTOC(0,"F")+;
			   BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0,"F")+BINTOC(0,"F")+;
			   BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0.33,"F")+BINTOC(0,"F")+BINTOC(0,"F")+;
			   BINTOC(0,"F")+BINTOC(0,"F")+BINTOC(0,"F")+BINTOC(1,"F")+BINTOC(0,"F")+;
			   BINTOC(0,"F")+BINTOC(0,"F")+BINTOC(0,"F")+BINTOC(0,"F")+BINTOC(1,"F")
			.Parent.AddProperty("cMatrix",lcMatrix)
		ENDIF

		.Draw()
		IF .Enabled = .F. 
			.Enabled = .F.
		ENDIF  

		ENDWITH 
		RETURN
	ENDPROC
	
	PROCEDURE Destroy
		WITH This
			.DeleteTemp
			IF .Parent.hImgAttrib1 > 0
				* Clear The ImageAttributes
				= GdipDisposeImageAttributes(.Parent.hImgAttrib1)
				.Parent.hImgAttrib1 = 0
			ENDIF
		ENDWITH
	ENDPROC
ENDDEFINE
